﻿using System;
using System.Collections.Generic;
using System.Linq;
using System.Net;
using System.Windows;
using System.Windows.Controls;
using System.Windows.Documents;
using System.Windows.Input;
using System.Windows.Media;
using System.Windows.Media.Animation;
using System.Windows.Shapes;

namespace SimPassport
{
    public partial class Japan : UserControl
    {
        private const double LEFT_OFFSET = -63.88;
        private const double TOP_OFFSET = -26.45;

        #region Dependency Property

        public static DependencyProperty CenterXProperty =
            DependencyProperty.Register("CenterX", typeof(double), typeof(Japan), new PropertyMetadata(centerXChanged));

        private static void centerXChanged(DependencyObject d, DependencyPropertyChangedEventArgs e)
        {
            Japan j = d as Japan;
            double value = (double)e.NewValue;
            j.shape.SetValue(Canvas.LeftProperty, LEFT_OFFSET - value);
            j.outer.SetValue(Canvas.LeftProperty, value);
        }

        public static DependencyProperty CenterYProperty =
            DependencyProperty.Register("CenterY", typeof(double), typeof(Japan), new PropertyMetadata(centerYChanged));

        private static void centerYChanged(DependencyObject d, DependencyPropertyChangedEventArgs e)
        {
            Japan j = d as Japan;
            double value = (double)e.NewValue;
            j.shape.SetValue(Canvas.TopProperty, TOP_OFFSET - value);
            j.outer.SetValue(Canvas.TopProperty, value);
        }

        public static DependencyProperty ScaleProperty =
            DependencyProperty.Register("Scale", typeof(double), typeof(Japan), new PropertyMetadata(ScaleChanged));

        private static void ScaleChanged(DependencyObject d, DependencyPropertyChangedEventArgs e)
        {
            Japan j = d as Japan;
            double value = (double)e.NewValue;
            j.st.ScaleX = value;
            j.st.ScaleY = value;
        }

        #endregion

        #region Property

        public double CenterX
        {
            get
            {
                return (double)this.GetValue(CenterXProperty);
            }
            set
            {
                this.SetValue(CenterXProperty, value);
            }
        }

        public double CenterY
        {
            get
            {
                return (double)this.GetValue(CenterYProperty);
            }
            set
            {
                this.SetValue(CenterYProperty, value);
            }
        }

        public double Scale
        {
            get
            {
                return (double)this.GetValue(ScaleProperty);
            }
            set
            {
                this.SetValue(ScaleProperty, value);
            }
        }

        #endregion

        public Japan()
        {
            InitializeComponent();
        }
    }
}
